package
{
	import mx.core.UIComponent;

	public class PlaybackCursor extends UIComponent
	{
		
		private var cursor:PlaybackCursorSymbol;
		
		private var _value:Number			= 0;
		private var valueDirty:Boolean 		= false;
		
		public function get value():Number { return _value; }
		public function set value(num:Number):void
		{
			if(isNaN(num) || num < 0 || num > 100)
			{
				throw new Error("PlaybackCursor::value setter, value must be between 0 and 100.");
				return;
			}
			_value = num;
			valueDirty = true;
			invalidateProperties();
		}
		
		public function PlaybackCursor()
		{
			super();
		}
		
		protected override function createChildren():void
		{
			super.createChildren();
			
			cursor = new PlaybackCursorSymbol();
			addChild(cursor);
		}
		
		protected override function commitProperties():void
		{
			super.commitProperties();
			
			if(valueDirty)
			{
				valueDirty 					= false;
				var percent:uint			= Math.round((value / 100) * 100);
				if(percent == 0) percent	= 1;
				cursor.preloadBar.gotoAndStop(percent);
			}
		}
		
	}
}